#include <bits/stdc++.h>
using namespace std;
const long maxN=1e6+3;
vector<pair<long,stack<long> > > a;

int main(){
ios_base::sync_with_stdio(0);
cin.tie(NULL);
cout.tie(NULL);
long n,sb=0; cin>>n;
stack<long> st; st.push(0);
a.push_back({0,st});
for(long i=0;i<n;i++){
    long p,m; cin>>p>>m;
    if(m!=0) {
        long q;
        tie(q,st)=a[p];
        st.push(m);
        q+=m;
        a.push_back({q,st});
        sb+=q;
    }
    else {
        long q;
        tie(q,st)=a[p];
        q-=st.top();
        st.pop();
        a.push_back({q,st});
        sb+=q;
    }
}
cout<<sb<<'\n';

return 0;
}
